#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2002-2003 Free Software Foundation
#
# FILE:
# Event.py
#
# DESCRIPTION:
#
# NOTES:
#

from gnue.common.apps import GDebug

class Event:
  """
    UserInteraction-Event (Mouseclick, Keypress)
  """
  def __init__(self):
    self._type = none
    self._keycode = -1
    self._x = -1
    self._y = -1

  def getKeycode(self):
    """
      return the code of the pressed key
    """
    return self._keycode

  def isMouseEvent(self):
    """
      return wether this event is a mouse event
    """
    return self._type == mouse

  def getX(self):
    """
      return the x-position of a mouse-event
      -1 if the event is not mouse-related
    """
    return self._x

  def getY(self):
    """
      return the y-position of a mouse-event
      -1 if the event is not mouse-related
    """
    return self._y

