#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2000-2003 Free Software Foundation
#
# FILE:
# Event.py
#
# DESCRIPTION:
#
# NOTES:
#

from gnue.common.apps import GDebug
import string

#
# Basic event passed between items
#
# If event = Event('MYEVENT',x=1, y=2, object=MyObject), then
#   event.event == 'MYEVENT', event.x = 1,
#   event.y == 2, and event.object == MyObject
#
class Event:
  def __init__(self, event, data=None, **parms):

    self.__dict__.update(parms)

    # TODO: Get rid of data=
    self.data  = data

    self.__event__ = event
    self.__result__ = None
    self.__dropped__ = 0
    self.__error__ = 0
    self.__errortext__ = ""
    self.__after__ = []


  def getResult(self):
    return self.__result__

  def setResult(self, value):
    self.__result__ = value

  def getEvent(self):
    return self.__event__

  def drop(self):
    self.__dropped__ = 0

  def setError(self, text = ""):
    self.__error__ = 1
    self.__errortext__ = text

  def dispatchAfter(self, *args, **parms):
    self.__after__.append((args, parms))
