#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2002-2003 Free Software Foundation
#
# FILE:
# Objects.py
#
# DESCRIPTION:
# GObjects for the Schema definitions
#
# NOTES:
#

from gnue.common.definitions.GObjects import GObj
from gnue.common.definitions.GRootObj import GRootObj
import GSParser

class GSObject(GObj):
  pass

class GSSchema(GRootObj, GSObject):
  def __init__(self, parent=None):
    GRootObj.__init__(self, 'schema', GSParser.getXMLelements, GSParser)
    GSObject.__init__(self, parent, type='GSSchema')

class GSTables(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSTables')

class GSTable(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSTable')

class GSFields(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSFields')

class GSField(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSField')
  
  def _buildObject(self):
    # TODO: Added with Common 0.5.0; deprecate at some point
    if hasattr(self,'auto') and self.auto:
      self.defaultwith="serial"
      self.auto = 0

    return GSObject._buildObject(self)

class GSPrimaryKey(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSPrimaryKey')

class GSPKField(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSPKField')

class GSConstraints(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSConstraints')

class GSConstraint(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSConstraint')

class GSConstraintField(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSConstraintField')

class GSConstraintRef(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSConstraintRef')

class GSIndexes(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSIndexes')

class GSIndex(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSIndex')

class GSIndexField(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSIndexField')

class GSData(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSData')

class GSTableData(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSTableData')

class GSRows(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSRows')

class GSRow(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSRow')

class GSValue(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSValue')

class GSDescription(GSObject):
  def __init__(self, parent):
    GSObject.__init__(self, parent, type='GSDescription')
